package com.holmos.webtest.element.tool;

import com.holmos.webtest.constvalue.ConstValue;
import com.holmos.webtest.element.locator.AbstractElement;
import com.holmos.webtest.element.locator.Locator;
import com.holmos.webtest.element.locator.LocatorChain;

/**
 * 用来判断数据结构是否存在的工具类
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public class WebElementExist {
	
	protected AbstractElement element;
	
	protected LocatorChain infoChain;
	
	protected Locator locator;
	
	public WebElementExist(AbstractElement element){
		this.element=element;
		this.infoChain=element.getInfoChain();
		this.locator=element.getLocator();
	}
	
	protected void initComment(){
		StringBuilder commentTemp=new StringBuilder();
		for(int i=0;i<infoChain.getInfoNodes().size();i++){
			commentTemp.append(infoChain.getInfoNodes().get(i).getComment()+"-->");
		}
		commentTemp.append(element.getComment());
		element.setWholeComment(commentTemp.toString());
	}
	
	/**
	 * 自己设置等待次数，一次50ms
	 * @param WaitCount 等待次数
	 * */
	public boolean isElementExist(int WaitCount){
		return false;
	}
	
	/**只等待一次*/
	public boolean isElementExistForCheckOnce(){
		return false;
	}
	public int getListElementSize(){
		return ConstValue.ERROR;
	}
	public int getCollectionSize(){
		return ConstValue.ERROR;
	}
	
}
