package com.holmos.webtest.junitextentions.annotations;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * 标示残数源的注解<br>
 * <li>file:如果是文件类型，那么指示了文件的地址,用文件地址来判断文件类型</li>
 * <li>selector:如果是数据库类型，那么代表select语句</li>
 * <li>connectionName:如果是数据库类型，代表数据库连接，在此测试类里面指示</li>
 * <li>sourceID:当一个测试类有多个数据源的时候，用来给数据源标号，多个数据源不能的sourceId不能相同,否则框架会抛出异常</li>
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
@Retention(RetentionPolicy.RUNTIME)
public @interface Source {
	String file() default "";
	String selector() default "";
	String className() default "";
	String connectionName() default "";
	int sourceID() default -1;
}
