package com.holmos.webtest.junitextentions.parameters;

import java.util.ArrayList;
import java.util.HashMap;

import com.holmos.webtest.junitextentions.parameters.getter.DataGetter;
/**
 * 一组参数的参数信息
 * 
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public final class ParameterDataInfo {
	/**数据获取器*/
	private DataGetter dataGetter;
	public DataGetter getDataGetter() {
		return dataGetter;
	}
	/**参数数据信息缓冲池*/
	private HashMap<Integer,ArrayList<Object[]>>parameters;
	public ParameterDataInfo(DataGetter dataGetter){
		this.dataGetter=dataGetter;
		parameters=new HashMap<Integer, ArrayList<Object[]>>();
	}
	/**根据批量id信息获取参数*/
	public ArrayList<Object[]> getParameters(int[]ids){
		ArrayList<Object[]> result=new ArrayList<Object[]>();
		for(int id:ids){
			result.addAll(getParameters(id));
		}return result;
	}
	/**根据id信息获取参数*/
	public ArrayList<Object[]> getParameters(int id){
		ArrayList<Object[]> result=new ArrayList<Object[]>();
		if(parameters.get(id)==null){
			ArrayList<Object[]> parameter=dataGetter.getParameterByID(id);
			parameters.put(id,parameter);
			result.addAll(parameter);
		}else{
			result.addAll(parameters.get(id));
		}return result;
	}
	/**获取此数据源的全部参数列表信息*/
	public ArrayList<Object[]> getAllParameters(){
		if(parameters.get(-1)==null)
			parameters.put(-1, dataGetter.getAllParameter());
		return dataGetter.getAllParameter();
	}
}
