package com.holmos.webtest.junitextentions.parameters.getter;

import java.io.UnsupportedEncodingException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import com.holmos.webtest.exceptions.HolmosFailedError;
import com.holmos.webtest.junitextentions.parameters.database.ConnectionInfo;
/**
 * @author 吴银龙(sunshine307087558@gmail.com)
 * */
public final class DatabaseDataGetter extends AbstractDataGetter{
	/**数据库连接对象*/
	private ConnectionInfo connection=null;
	/**sql查询语句*/
	private String selectSql;
	public DatabaseDataGetter(String selectSql){
		this.selectSql=selectSql;
	}
	
	@Override
	public ArrayList<Object[]> getParameterByIDs(int[] ids) {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		for(int id:ids)
			result.addAll(getParameterByID(id));
		return result;
	}

	@Override
	public ArrayList<Object[]> getAllParameter() {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		ResultSet reSet=getSelectResult();
		try {
			for(reSet.next();;reSet.next()){
				result.add(getParameter(reSet));
				if(reSet.isLast())break;
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return result;
	}
	/**id为第一列*/
	private Object[] getParameter(ResultSet resultSet){
		ArrayList<Object>parameter=new ArrayList<Object>();
		try {
			parameter.add(resultSet.getInt(1));
			for(int i=2;i<=resultSet.getMetaData().getColumnCount();i++){
				Object rst=resultSet.getObject(i);
				if(rst instanceof String)
					parameter.add(new String(((String) rst).getBytes(),"GBK"));
				else
					parameter.add(rst);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return parameter.toArray();
	}
	public void setConnection(ConnectionInfo connection) {
		this.connection = connection;
	}

	@Override
	public ArrayList<Object[]> getParameterByID(int id) {
		ArrayList<Object[]>result=new ArrayList<Object[]>();
		if(id > getAllParameter().size() || id < 1){
			throw new HolmosFailedError("对于存储在数据库中的参数信息,在@Parameter里面的values" +
					"信息配置的是查找出来参数信息的行索引,based 1,此处配置的行索引超出了参数的组数,请检查!");
		}
		result.add(getAllParameter().get(id-1));
		return result;
	}
	/**
	 * 根据指定的sql，select语句来获得数据
	 * */
	private ResultSet getSelectResult(){
		try {
			Statement select=connection.getConnection().createStatement();
			return select.executeQuery(selectSql);
		} catch (SQLException e) {
			e.printStackTrace();
		}return null;
	}
	
}

